; 2013  ; sprin

; :
;  *  4-  MC P1 (MCp0411100101)

; -: 
; typedef unsigned int   UINT32, *PUINT32;
; UINT32 mc_POPCNT32_v1(UINT32 X);


.alias	SP	39	;   

.text

.global mc_POPCNT32_v1
mc_POPCNT32_v1:
	.alias	mc_PopCnt32.m1  0x55555555	; //binary: 0101...
	.alias	mc_PopCnt32.m2  0x33333333	; //binary: 00110011..
	.alias	mc_PopCnt32.m4  0x0f0f0f0f	; //binary:  4 zeros,  4 ones ...
	.alias	mc_PopCnt32.h01 0x01010101	; //the sum of 256 to the power of 0,1,2,3...

	.alias	mc_PopCnt32.RES   #SP, 4
	.alias	mc_PopCnt32.ARG1  #SP, 8

.local mc_PopCnt32.P0	;  13 
mc_PopCnt32.P0:
                ;  
 NextP :=       rdl	#SP
                jmp	@NextP

                ;   
 a1 :=          rdl	mc_PopCnt32.ARG1

 r1_1 :=        slrl	@a1, 0x1
 r1_2 :=        and	@r1_1, mc_PopCnt32.m1
 r1 :=          subl	@a1, @r1_2

 r2_1 :=        and	@r1, mc_PopCnt32.m2
 r2_2 :=        slrl	@r1, 0x2
 r2_3 :=	and	@r2_2, mc_PopCnt32.m2
 r2 :=          addl	@r2_3, @r2_1

 r3_1 :=        slrl	@r2, 0x4
 r3_2 :=        addl	@r2, @r3_1
 r3 :=          and	@r3_2, mc_PopCnt32.m4

 r4_1 :=        mull	@r3, mc_PopCnt32.h01	;      .
 r4 :=          slrl	@r4_1, 0x18		; 0x18 = 24

                ;     
                wrl	@r4, mc_PopCnt32.RES
complete

.end


;====================================================================

;  13 
T\C	1	2	3	4
1	1	2.	3	4.
2	5.	2	6.	4
3	5	7.	6.	8.
4	9.	7.	6	8.
5	9.	7	10.	8
6	9	11.	10.	12.
7	13.	11.	10	12.
8	13.	11	14.	12.
9	13.	15.	14.	12
10	13	15.	14.	16.
11	-	15.	14	16.
12	-	15	-	16.
13	-	-	-	16

;====================================================================
