; 2013  ; sprin

; :
;  *  4-  MC P1 (MCp0411100101)

; -: 
; typedef unsigned int   UINT32, *PUINT32;
; UINT32 mc_POPCNT32_v4(UINT32 X);

;  :
;  * ..    POPCNT     ,
;         ( ,    
;        ),      2 .


.alias	SP	39	;   

.text

.global mc_POPCNT32_v4
mc_POPCNT32_v4:
	.alias	mc_PopCnt32.m1  011111111111	; //binary: 01001001001001001001001001001001
	.alias	mc_PopCnt32.m2  033333333333	; //binary: 11011011011011011011011011011011
	.alias	mc_PopCnt32.m3  030707070707	; //binary: 11000111000111000111000111000111

	.alias	mc_PopCnt32.RES    #SP, 4
	.alias	mc_PopCnt32.ARG1   #SP, 8

.local mc_PopCnt32.P0	;  16 
mc_PopCnt32.P0:
                ;  
 NextP :=       rdl	#SP
                jmp	@NextP

                ;   
 a1 :=          rdl	mc_PopCnt32.ARG1

 a1l :=         and	@a1, 0xFFFF
 a1h :=         slrl	@a1, 0x10	; 0x10 (=16)

 rl1 :=         slrl	@a1l, 0x1
 rl2 :=         slrl	@a1l, 0x2
 rh1 :=         slrl	@a1h, 0x1
 rh2 :=         slrl	@a1h, 0x2
 rl3 :=         and	@rl1, mc_PopCnt32.m2
 rl4 :=         and	@rl2, mc_PopCnt32.m1
 rh3 :=         and	@rh1, mc_PopCnt32.m2
 rh4 :=         and	@rh2, mc_PopCnt32.m1
 rl5 :=         subl	@a1l, @rl3
 rh5 :=         subl	@a1h, @rh3
 rl6 :=         subl	@rl5, @rl4
 rh6 :=         subl	@rh5, @rh4

 rl7 :=         slrl	@rl6, 0x3
 rh7 :=         slrl	@rh6, 0x3
 rl8 :=         addl	@rl6, @rl7
 rh8 :=         addl	@rh6, @rh7
 rl9 :=         and	@rl8, mc_PopCnt32.m3
 rh9 :=         and	@rh8, mc_PopCnt32.m3

                ; x % 63
 rl10 :=        clf	@rl9
 rh10 :=        clf	@rh9
 rl11 :=        divf	@rl10, 0f63.0
 rh11 :=        divf	@rh10, 0f63.0
 rl12 :=        cfsl	@rl11
 rh12 :=        cfsl	@rh11
 rl13 :=        mull	@rl12, 63
 rh13 :=        mull	@rh12, 63
 rl19 :=        subl	@rl9, @rl13
 rh19 :=        subl	@rh9, @rh13

 l19 :=         addl	@rl19, @rh19

                ;     
                wrl	@l19, mc_PopCnt32.RES
complete

.end


;====================================================================

;  16 
T\C	1	2	3	4
1	1	2.	3	4.
2	5	2	6.	4
3	7	8	6	9
4	10	11	12	13
5	14	15	16.	17.
6	18.	19.	16	17
7	18	19	20.	21.
8	22.	23.	20	21
9	22	23	24.	25.
10	26.	27.	24	25
11	26	27	28.	29.
12	30.	31.	28	29
13	30	31	32.	33.
14	34.	35.	32	33
15	34	35.	-	-
16	-	35	-	-

;====================================================================
